#!/usr/bin/ksh
# ##############################################################
# gen-genfind.ksh - Copyright (c) 2002 MonkeyMental.com
# ##############################################################
# Description:
# Create a script that will be used to run find on each local 
# filesystem.
#
# ###################################################################
# Revision History:
# 02-01-17 - LO - Created.
# ###################################################################



get_sol_mount_points()
{
	$AWKCMD '
		{
			if(/^#/)
			{
				next;
			}
			if(/^$/)
			{
				next;
			}
			if($4 == fstype)
			{
				if($3 == "/")
				{
					mount = "root";
				}
				else
				{
					mount = $3;
				}
				print "echo \"find "$3" -xdev -exec /usr/local/migrate/migrate_uid.ksh {} `basename "mount"` \\; \&\"\>\>runfind.ksh";
			}
		}
	' fstype=${FSTYPE} ${FSSOURCE}
}

get_lnx_mount_points()
{
	$AWKCMD '
		{
			if(/^#/)
			{
				next;
			}
			if(/^$/)
			{
				next;
			}
			if($3 == fstype)
			{
				if($2 == "/")
				{
					mount = "root";
				}
				else
				{
					mount = $2;
				}
				print "echo \"find "$2" -xdev -exec /usr/local/migrate/migrate_uid.ksh {} `basename "mount"` \\; \&\"\>\>runfind.ksh";
			}
		}
	' fstype=${FSTYPE} ${FSSOURCE}
}

get_aix_mount_points()
{
	$AWKCMD '
		{
			if(!/^\//)
			{
				next;
			}
			if($7 == "/")
			{
				mount = "root";
			}
			else
			{
				mount = $7;
			}
			print "echo \"find "$7" -xdev -exec /usr/local/migrate/migrate_uid.ksh {} `basename "mount"` \\; \&\"\>\>runfind.ksh";
		}
	' ${FSSOURCE}
}

get_hpux_mount_points()
{
	$AWKCMD '
		{
			if(!/^\//)
			{
				next;
			}
			if($6 == "/")
			{
				mount = "root";
			}
			else
			{
				mount = $6;
			}
				print "echo \"find "$6" -xdev -exec /usr/local/migrate/migrate_uid.ksh {} `basename "mount"` \\; &\">>runfind.ksh";
		}
	' ${FSSOURCE}
}


# ###################################################################
# main() - Script begins here
# ###################################################################


# Check to see that awk is where we think it is
case `uname -s` in
    AIX )
    if [[ -f "/usr/bin/awk" ]]; then
        AWKCMD="/usr/bin/awk"
    else
        print "echo awk not installed as /usr/bin/awk";
        exit
    fi
	FSSOURCE="/tmp/dfout";
	/usr/bin/df > ${FSSOURCE};
	get_aix_mount_points;
    ;;

    HP-UX )
    if [[ -f "/usr/bin/awk" ]]; then
        AWKCMD="/usr/bin/awk"
    else
        print "echo awk not installed as /usr/bin/awk";
        exit
    fi
	FSSOURCE="/tmp/dfout";
	/usr/bin/bdf -l >${FSSOURCE};
	get_hpux_mount_points;
    ;;

    SunOS )
    if [[ -f "/usr/bin/nawk" ]]; then
        AWKCMD="/usr/bin/nawk"
    else
        print "echo awk not installed as /usr/bin/nawk";
        exit
    fi
	FSTYPE="ufs";
	FSSOURCE="/etc/vfstab";
	get_sol_mount_points;
    ;;

    Linux )
    if [[ -f "/usr/bin/gawk" ]]; then
        AWKCMD="/usr/bin/gawk"
    else
        print "echo awk not installed as /usr/bin/gawk";
        exit
    fi
	FSTYPE="ext2";
	FSSOURCE="/etc/fstab";
	get_lnx_mount_points;
    ;;

	* )
		echo "echo Unsuported OS";
	;;
esac

